/*
 * Decompiled with CFR 0.152.
 */
package fire.pb.map;

import fire.pb.map.Position;

public abstract class Body {
    private final long uniqueID;
    private final int kind;
    private long sceneId;
    private Position pos;
    public static final int TYPE_ROLE = 1;
    public static final int TYPE_NPC = 2;
    public static final int TYPE_PET = 3;
    public static final int TYPE_PICKUP = 4;

    public Body(long uniqueID, int kind) {
        this.uniqueID = uniqueID;
        this.kind = kind;
    }

    public long getUniqueID() {
        return this.uniqueID;
    }

    public int getKind() {
        return this.kind;
    }

    public boolean equals(Body o) {
        if (null == o) {
            return false;
        }
        return this.kind == o.kind && this.uniqueID == o.uniqueID;
    }

    public Position getPos() {
        return this.pos;
    }

    public void setPos(Position pos) {
        this.pos = pos;
    }

    public long getScene() {
        return this.sceneId;
    }

    public int getMapId() {
        return (int)this.sceneId;
    }

    public void setScene(long sceneId) {
        this.sceneId = sceneId;
    }

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    public void updateMapInfo(long sceneId, int posx, int posy, int posz) {
        Body body = this;
        synchronized (body) {
            this.setScene(sceneId);
            this.setPos(new Position(posx, posy, posz));
        }
    }

    public boolean checkDistance(Body o, int distance) {
        if (this.getScene() == 0L || o.getScene() == 0L) {
            return false;
        }
        if (this.getScene() != o.getScene()) {
            return false;
        }
        if (this.getPos().getX() < 0 || o.getPos().getX() < 0) {
            return false;
        }
        if (this.getPos().getZ() != o.getPos().getZ()) {
            return false;
        }
        return this.getPos().getDistance(o.getPos()) <= distance;
    }
}

